'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const app_worker_loader_1 = require("./app_worker_loader");
exports.AppWorkerLoader = app_worker_loader_1.default;
const agent_worker_loader_1 = require("./agent_worker_loader");
exports.AgentWorkerLoader = agent_worker_loader_1.default;
const path = require("path");
exports.egg = require('egg');
exports.EGG_PATH = Symbol.for('egg#eggPath');
exports.EGG_LOADER = Symbol.for('egg#loader');
const startCluster = exports.egg.startCluster;
exports.startCluster = startCluster;
exports.EGGApplication = exports.egg.Application;
class Application extends exports.EGGApplication {
    constructor(options) {
        super(options);
    }
    get [exports.EGG_PATH]() {
        return path.dirname(__dirname);
    }
    get [exports.EGG_LOADER]() {
        return app_worker_loader_1.default;
    }
    GetComponent(classType) {
        const context = this.iocContext;
        return context.get(classType);
    }
}
exports.Application = Application;
exports.EGGAgent = exports.egg.Agent;
class Agent extends exports.EGGAgent {
    get [exports.EGG_PATH]() {
        return path.dirname(__dirname);
    }
    get [exports.EGG_LOADER]() {
        return agent_worker_loader_1.default;
    }
    constructor(options) {
        super(options);
    }
}
exports.Agent = Agent;
