"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tsNode = require("ts-node");
const fs = require("fs");
const path = require("path");
const tsConfigPaths = require("tsconfig-paths");
function loadFile(path) {
    try {
        return require(path);
    }
    catch (err) {
        err.message = `[egg-typed] load file: ${path}, error: ${err.message}`;
        throw err;
    }
}
exports.loadFile = loadFile;
function getTSConfig(baseDir) {
    if (!fs.existsSync(path.join(baseDir, 'tsconfig.json'))) {
        console.warn('tsconfig.json NOT FOUND! path:', baseDir);
        return;
    }
    return JSON.parse(fs.readFileSync(path.join(baseDir, 'tsconfig.json'), { encoding: 'utf8' }) || '{}');
}
function registerTSNode(baseDir) {
    const config = Object.assign({}, getTSConfig(baseDir));
    tsNode.register(Object.assign({}, config));
    tsConfigPaths.register({
        baseUrl: baseDir,
        paths: config.compilerOptions.paths,
    });
}
exports.registerTSNode = registerTSNode;
