import { Context } from 'egg';
import { SceneTestBase, ReqTestBase, SceneData, TestReqData } from '../../test/base';
export declare class TestController {
    private config;
    private readonly sceneRootDir;
    constructor(ctx: Context);
    getSceneTest(id: string): SceneTestBase<ReqTestBase>;
    getReqTestPath(sid: string, rid: string): string;
    getReqTest(sid: string, rid: string): ReqTestBase;
    getSceneList(): SceneData[];
    getScene(id: string): {
        req: TestReqData[];
        id: string;
        title: string;
        description?: string;
    };
    addScene(id: string, title: string): boolean;
    removeScene(id: string): void;
    saveScene(id: string, data: SceneData): {
        req: TestReqData[];
        id: string;
        title: string;
        description?: string;
    };
    getSceneCase(id: string): TestReqData[];
    createSceneReq(id: string, data?: TestReqData): {
        req: TestReqData[];
        id: string;
        title: string;
        description?: string;
    };
    removeSceneReq(id: string, rid: string): void;
    createSceneReqByTracking(id: string, tid: number, title: string): TestReqData;
    onlineTest(id: string, rid: string): Promise<{
        status: number;
        body: any;
        err: any;
    }>;
    updateTest(id: string, rid: string): Promise<{
        status: number;
        body: any;
        err: any;
    }>;
    private mkdir;
    private getEdgeCall;
}
