"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function toHyphenCase(s) {
    s = s.replace(/([A-Z])/g, '_$1').toLowerCase();
    if (s.startsWith('_')) {
        s = s.substr(1);
    }
    return s;
}
exports.toHyphenCase = toHyphenCase;
function toCamelCase(s) {
    return s.replace(/_(\w)/g, function (_all, letter) {
        return letter.toUpperCase();
    });
}
exports.toCamelCase = toCamelCase;
function guard(func, defaultValue, onError) {
    try {
        return func();
    }
    catch (error) {
        return (onError && onError(error)) || defaultValue;
    }
}
exports.guard = guard;
