"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const egg_typed_tracking_1 = require("egg-typed-tracking");
exports.noTrackingSymbol = Symbol('no-tracking');
// TODO 待分离tracking插件
exports.trackingMiddleware = (app, typeInfo) => {
    if (app.config.et.useTracking) {
        if (typeInfo.noTracking) {
            return (ctx, next) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                Object.defineProperty(ctx, exports.noTrackingSymbol, {
                    configurable: false,
                    enumerable: false,
                    value: true
                });
                next();
            });
        }
        else {
            return (ctx, next) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                if (!ctx[egg_typed_tracking_1.trackExtInfoSymbol]) {
                    ctx[egg_typed_tracking_1.trackExtInfoSymbol] = {};
                }
                const trackData = ctx[egg_typed_tracking_1.trackExtInfoSymbol];
                trackData.originalUrl = ctx.request.originalUrl;
                trackData.path = ctx.request.path;
                trackData.method = ctx.request.method;
                trackData.header = JSON.parse(JSON.stringify(ctx.request.header));
                trackData.params = ctx.request.params;
                trackData.query = ctx.request.query;
                trackData.body = JSON.parse(JSON.stringify(ctx.request.body));
                trackData.route = {
                    name: typeInfo.name,
                    description: typeInfo.description,
                };
                try {
                    yield next();
                    trackData.trackingId = trackData.header['tracking-id'] || ctx.header['request-id'];
                    trackData.result = {
                        status: ctx.status,
                        body: ctx.body
                    };
                }
                catch (error) {
                    trackData.result = {
                        status: error.status,
                        error: {
                            code: error.code,
                            message: error.message,
                        },
                        errStr: error.toString(),
                    };
                    throw error;
                }
            });
        }
    }
};
