"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const request = require("request");
const base_1 = require("./base");
class ReqTest extends base_1.ReqTestBase {
    runTest() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const { info } = this;
            this.startMockData();
            return new Promise((resolve, _reject) => {
                const isFormData = info.header['content-type'] === 'application/x-www-form-urlencoded';
                const req = request(info.url, {
                    baseUrl: `http://${info.header.host}`,
                    method: info.method,
                    headers: info.header,
                    formData: isFormData ? info.body : undefined,
                    body: isFormData ? undefined : JSON.stringify(info.body),
                }, (err, res, body) => {
                    this.stopMockData();
                    resolve({
                        status: res && res.statusCode,
                        body,
                        err: JSON.parse(JSON.stringify(err)),
                    });
                });
            });
        });
    }
}
exports.ReqTest = ReqTest;
