'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const ts = require("typescript");
const util_1 = require("egg-controller/lib/transformer/util");
console.log('[egg-typed] load transformer: inject (circle).');
function transformer(_) {
    return {
        after(ctx) {
            return (sourceFile) => {
                sourceFile.statements
                    .filter(n => ts.isExpressionStatement(n) && ts.isCallExpression(n.expression))
                    .forEach((node) => {
                    const decExpr = node.expression;
                    if (ts.isIdentifier(decExpr.expression) && decExpr.expression.text === '__decorate') {
                        const arg = decExpr.arguments[0];
                        if (arg.elements.filter(el => ts.isCallExpression(el)).some((el) => {
                            return ts.isIdentifier(el.expression) && (el.expression.text === 'inject' || el.expression.text === 'lazyInject');
                        })) {
                            const metaExpr = arg.elements
                                .filter(el => ts.isCallExpression(el))
                                .find((el) => {
                                const arg = el.arguments && el.arguments[0];
                                return ts.isIdentifier(el.expression) &&
                                    el.expression.text === '__metadata' &&
                                    arg.text === 'design:type';
                            });
                            if (metaExpr) {
                                const targetArg = metaExpr.arguments[1];
                                metaExpr.arguments = ts.createNodeArray([
                                    metaExpr.arguments[0],
                                    ts.createFunctionExpression(undefined, undefined, ts.createIdentifier(`${targetArg.escapedText}FC`), undefined, ts.createNodeArray([ts.createParameter(undefined, undefined, undefined, ts.createIdentifier('ctx'))]), undefined, ts.createBlock([
                                        ts.createReturn(ts.createCall(
                                        // 返回 Object.keys
                                        ts.createPropertyAccess(ts.createIdentifier('ctx'), ts.createIdentifier('getComponent')), undefined, [targetArg])),
                                    ]))
                                ]);
                            }
                        }
                    }
                });
                return util_1.walker(sourceFile, ctx);
            };
        },
    };
}
exports.default = transformer;
