import { GetReturnType, ClassType } from 'power-di';
import { app } from 'egg-mock/bootstrap';
import { ReqTestBase, SceneTestBase } from './lib/test/base';
import { BaseModel, BaseRepository } from './orm';
/**
 * getAllTestScene
 * @param testSceneDir
 * @param whiteList scene id list
 */
export declare function getAllTestScene(testSceneDir: string, whiteList?: string[]): SceneTest[];
export declare class ReqTest extends ReqTestBase {
    runTest(context: any): void;
}
export declare class SceneTest extends SceneTestBase<ReqTest> {
    protected loadReqTest(): void;
    /**
     * run req test
     * @param reqWhiteList req id list
     */
    runTest(reqWhiteList?: string[]): void;
}
export declare type MockType<T> = {
    [P in keyof T]?: any;
};
export declare class GlobalMock {
    private mockData;
    start(): void;
    mock(type: ClassType, mockFunc: (inst: any) => void): void;
    stop(): void;
    private hook;
}
export declare class TestSuite {
    readonly app: typeof app;
    readonly ctx: any;
    readonly globalMock: GlobalMock;
    constructor(_app?: typeof app);
    get<T = undefined, KeyType = any>(clsType: KeyType): GetReturnType<T, KeyType>;
    mock<T extends ClassType>(type: T, func: (inst: MockType<InstanceType<T>>) => void): void;
    getRepo<T extends typeof BaseModel>(modelType: T): BaseRepository<any, any>;
    mockRepo<T extends typeof BaseModel>(modelType: T, func: (inst: MockType<BaseRepository>) => void): void;
}
export declare function getTestSuite(): TestSuite;
/** 直接 mock class proto */
export declare function mockProto<T, K extends keyof T, P>(proto: T, method: K, mockData: T[K] extends (...args: P[]) => any ? (...args: P[]) => ReturnType<T[K]> extends Promise<infer X> ? Partial<X> | Promise<Partial<X>> : Partial<ReturnType<T[K]>> : T[K]): void;
